<?php
/**
*
* @package Last 3 X made by User v.0.0.2
* @version $Id: functions_last_x.php 10214 2011-09-10 01:30:55MEZ 4_seven $
* @copyright (c)  / 4seven / 2011
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}


// Last 3 X made by User v.0.0.2 / 4seven / 2011

// Do all settings here

    // Max. Signs of 'Short Topic Title' 
    $topic_title_length = 25;
	
	// Enable/Disable Last 3 Topics: true/false
	$last_topics_true   = true;
	
	// Enable/Disable Last 3 Posts: true/false
	$last_posts_true    = true;

// Point of no return

if (!isset($post_three))   
{
    $post_three[] = 0;
}

if ($last_topics_true){

$template->assign_var('S_LAST_TOPICS', true);

function show_last_topics($topic_poster = 0, $forum_id = 0, $forum_ary){

global $auth, $db;

$sql = 'SELECT f.forum_name, t.topic_id, t.forum_id, t.topic_title, t.topic_time
            FROM ' . FORUMS_TABLE . ' f, ' . TOPICS_TABLE . ' t
            WHERE t.topic_poster = ' . (int) $topic_poster . '
            AND f.forum_id = t.forum_id
            AND ' . $db->sql_in_set('t.forum_id', $forum_ary) . ' 
            ORDER BY topic_time DESC';
			
$result        = $db->sql_query_limit($sql, 3, false, 600);
$last_topics   = $db->sql_fetchrowset($result);				
                 $db->sql_freeresult($result);

return	$last_topics;}

}

else{

function show_last_topics($topic_poster = 0, $forum_id = 0, $forum_ary){
return	false;}

}

if ($last_posts_true){

$template->assign_var('S_LAST_POSTS', true);

function show_last_posts($post_poster = 0, $forum_id = 0, $forum_ary){

global $auth, $db;

$sql = 'SELECT p.post_id, p.forum_id, p.post_time, p.post_subject, t.topic_title, f.forum_name
            FROM ' . POSTS_TABLE . ' p
            INNER JOIN ' . TOPICS_TABLE . ' t ON (p.topic_id = t.topic_id)
            INNER JOIN ' . FORUMS_TABLE . ' f ON (p.forum_id = f.forum_id)
            WHERE p.poster_id = ' . (int) $post_poster . '
            AND ' . $db->sql_in_set('p.forum_id', $forum_ary) . ' 
            ORDER BY p.post_time DESC';
			
$result       = $db->sql_query_limit($sql, 3, false, 600);
$last_posts   = $db->sql_fetchrowset($result);	
                $db->sql_freeresult($result);

return	$last_posts;}

}

else{

function show_last_posts($topic_poster = 0, $forum_id = 0, $forum_ary){
return	false;}

}

if ($last_topics_true || $last_posts_true){
		
        $forum_ary = array();
        $forum_read_ary = $auth->acl_getf('f_read');

        foreach ($forum_read_ary as $forum_id => $allowed){
        if ($allowed['f_read']){
        $forum_ary[] = (int) $forum_id;}}

        $forum_ary = array_intersect(array_keys($auth->acl_getf('f_read', true)), array_keys($auth->acl_getf('f_download', true)));
	
        $sql = 'SELECT post_id, poster_id
				FROM  ' . POSTS_TABLE . '
                WHERE ' . $db->sql_in_set('post_id', $post_three);
        $result = $db->sql_query_limit($sql, sizeof($post_three), false, 777);

        $post_three = array_flip($post_three);

    while ($row = $db->sql_fetchrow($result)){
 
        $rownr = $post_three[$row['post_id']];

		$last_topics = show_last_topics($row['poster_id'], $forum_id, $forum_ary);
		$last_topics_count = count($last_topics);
		
		$last_posts = show_last_posts($row['poster_id'], $forum_id, $forum_ary);
		$last_posts_count = count($last_posts);
		

    $template->alter_block_array('postrow', array(
		
	// Last 3 Topics made by User v.0.0.2 / 4seven / 2011	
	'LAST_X_TOPICS_COUNT_O_1' => ($last_topics_count == 1) ? $user->lang['LAST'] . ' ' . $user->lang['TOPIC'] : '',	
	'LAST_X_TOPICS_COUNT_U_2' => ($last_topics_count > 1) ? $user->lang['LATEST'] . ' ' . count($last_topics) . ' ' . $user->lang['TOPICS'] : '',
	'LAST_X_TOPICS_COUNT_U_1' => ($last_topics_count == 0) ? $user->lang['NO_LATEST'] . ' ' . $user->lang['TOPICS'] : '',
		
	'LAST_X_TOPICS_EXIST_1'  => (isset($last_topics[0]['topic_id'])) ? true : false,
	'LAST_X_TOPICS_SHORT_1'  => (isset($last_topics[0]['topic_id'])) ? (strlen(censor_text($last_topics[0]['topic_title'])) < $topic_title_length) ? censor_text($last_topics[0]['topic_title']) : mb_substr(stripslashes(censor_text($last_topics[0]['topic_title'])), 0, $topic_title_length) . '...' : '',
	
	'LAST_X_TOPICS_LONG_1'   => (isset($last_topics[0]['topic_id'])) ? addslashes(censor_text($last_topics[0]['topic_title'])) : '',
	'LAST_X_TOPICS_LINK_1'   => (isset($last_topics[0]['topic_id'])) ? append_sid("{$phpbb_root_path}viewtopic.$phpEx", 'f=' . $last_topics[0]['forum_id']) . '&amp;t=' . $last_topics[0]['topic_id'] : '',
	'LAST_X_FORUMS_LONG_1'   => (isset($last_topics[0]['topic_id'])) ? addslashes(censor_text($last_topics[0]['forum_name'])) : '',
	'LAST_X_DATE_TIME_1'     => (isset($last_topics[0]['topic_id'])) ? $user->format_date($last_topics[0]['topic_time']) : '',	
		
	'LAST_X_TOPICS_EXIST_2'  => (isset($last_topics[1]['topic_id'])) ? true : false,
	'LAST_X_TOPICS_SHORT_2'  => (isset($last_topics[1]['topic_id'])) ? (strlen(censor_text($last_topics[1]['topic_title'])) < $topic_title_length) ? censor_text($last_topics[1]['topic_title']) : mb_substr(stripslashes(censor_text($last_topics[1]['topic_title'])), 0, $topic_title_length) . '...' : '',
	
	'LAST_X_TOPICS_LONG_2'   => (isset($last_topics[1]['topic_id'])) ? addslashes(censor_text($last_topics[1]['topic_title'])) : '',
	'LAST_X_TOPICS_LINK_2'   => (isset($last_topics[1]['topic_id'])) ? append_sid("{$phpbb_root_path}viewtopic.$phpEx", 'f=' . $last_topics[1]['forum_id']) . '&amp;t=' . $last_topics[1]['topic_id'] : '',
	'LAST_X_FORUMS_LONG_2'   => (isset($last_topics[1]['topic_id'])) ? addslashes(censor_text($last_topics[1]['forum_name'])) : '',
	'LAST_X_DATE_TIME_2'     => (isset($last_topics[1]['topic_id'])) ? $user->format_date($last_topics[1]['topic_time']) : '',
		
	'LAST_X_TOPICS_EXIST_3'  => (isset($last_topics[2]['topic_id'])) ? true : false,
	'LAST_X_TOPICS_SHORT_3'  => (isset($last_topics[2]['topic_id'])) ? (strlen(censor_text($last_topics[2]['topic_title'])) < $topic_title_length) ? censor_text($last_topics[2]['topic_title']) : mb_substr(stripslashes(censor_text($last_topics[2]['topic_title'])), 0, $topic_title_length) . '...' : '',
	
	'LAST_X_TOPICS_LONG_3'   => (isset($last_topics[2]['topic_id'])) ? addslashes(censor_text($last_topics[2]['topic_title'])) : '',
	'LAST_X_TOPICS_LINK_3'   => (isset($last_topics[2]['topic_id'])) ? append_sid("{$phpbb_root_path}viewtopic.$phpEx", 'f=' . $last_topics[2]['forum_id']) . '&amp;t=' . $last_topics[2]['topic_id'] : '',
	'LAST_X_FORUMS_LONG_3'   => (isset($last_topics[2]['topic_id'])) ? addslashes(censor_text($last_topics[2]['forum_name'])) : '',
	'LAST_X_DATE_TIME_3'     => (isset($last_topics[2]['topic_id'])) ? $user->format_date($last_topics[2]['topic_time']) : '',
	// Last 3 Topics made by User v.0.0.2 / 4seven / 2011	

	// Last 3 Posts made by User v.0.0.2 / 4seven / 2011		
	'LAST_X_POSTS_COUNT_O_1' => ($last_posts_count == 1) ? $user->lang['LAST'] . ' ' . $user->lang['POST'] : '',	
	'LAST_X_POSTS_COUNT_U_2' => ($last_posts_count > 1) ? $user->lang['LATEST'] . ' ' . count($last_posts) . ' ' . $user->lang['POSTS'] : '',
	'LAST_X_POSTS_COUNT_U_1' => ($last_posts_count == 0) ? $user->lang['NO_LATEST'] . ' ' . $user->lang['POSTS'] : '',
	
	'LAST_X_POSTS_EXIST_1'   => (isset($last_posts[0]['post_id'])) ? true : false,	
	'LAST_X_POSTS_LINK_1'    => (isset($last_posts[0]['post_id'])) ? append_sid("{$phpbb_root_path}viewtopic.$phpEx", 'f=' . $last_posts[0]['forum_id']) . '&amp;p=' . $last_posts[0]['post_id'] . '#p' . $last_posts[0]['post_id'] : '',
	'LAST_X_POSTS_SHORT_1'   => (isset($last_posts[0]['post_id'])) ? (strlen(censor_text($last_posts[0]['post_subject'])) < $topic_title_length) ? censor_text($last_posts[0]['post_subject']) : mb_substr(stripslashes(censor_text($last_posts[0]['post_subject'])), 0, $topic_title_length) . '...' : '',
	'LAST_X_POSTS_LONG_1'    => (isset($last_posts[0]['post_id'])) ? addslashes(censor_text($last_posts[0]['post_subject'])) : '',
	'LAST_X_POSTS_F_LONG_1'  => (isset($last_posts[0]['post_id'])) ? addslashes(censor_text($last_posts[0]['forum_name'])) : '',
	'LAST_X_POSTS_T_LONG_1'  => (isset($last_posts[0]['post_id'])) ? addslashes(censor_text($last_posts[0]['topic_title'])) : '',
	'LAST_X_POSTS_DATE_1'    => (isset($last_posts[0]['post_id'])) ? ($user->format_date($last_posts[0]['post_time'])) : '',
		
	'LAST_X_POSTS_EXIST_2'   => (isset($last_posts[1]['post_id'])) ? true : false,	
	'LAST_X_POSTS_LINK_2'    => (isset($last_posts[1]['post_id'])) ? append_sid("{$phpbb_root_path}viewtopic.$phpEx", 'f=' . $last_posts[1]['forum_id']) . '&amp;p=' . $last_posts[1]['post_id'] . '#p' . $last_posts[1]['post_id'] : '',
	'LAST_X_POSTS_SHORT_2'   => (isset($last_posts[1]['post_id'])) ? (strlen(censor_text($last_posts[1]['post_subject'])) < $topic_title_length) ? censor_text($last_posts[1]['post_subject']) : mb_substr(stripslashes(censor_text($last_posts[1]['post_subject'])), 0, $topic_title_length) . '...' : '',
	'LAST_X_POSTS_LONG_2'    => (isset($last_posts[1]['post_id'])) ? addslashes(censor_text($last_posts[1]['post_subject'])) : '',
	'LAST_X_POSTS_F_LONG_2'  => (isset($last_posts[1]['post_id'])) ? addslashes(censor_text($last_posts[1]['forum_name'])) : '',
	'LAST_X_POSTS_T_LONG_2'  => (isset($last_posts[1]['post_id'])) ? addslashes(censor_text($last_posts[1]['topic_title'])) : '',
	'LAST_X_POSTS_DATE_2'    => (isset($last_posts[1]['post_id'])) ? ($user->format_date($last_posts[1]['post_time'])) : '',
	
	'LAST_X_POSTS_EXIST_3'   => (isset($last_posts[2]['post_id'])) ? true : false,	
	'LAST_X_POSTS_LINK_3'    => (isset($last_posts[2]['post_id'])) ? append_sid("{$phpbb_root_path}viewtopic.$phpEx", 'f=' . $last_posts[2]['forum_id']) . '&amp;p=' . $last_posts[2]['post_id'] . '#p' . $last_posts[2]['post_id'] : '',
	'LAST_X_POSTS_SHORT_3'   => (isset($last_posts[2]['post_id'])) ? (strlen(censor_text($last_posts[2]['post_subject'])) < $topic_title_length) ? censor_text($last_posts[2]['post_subject']) : mb_substr(stripslashes(censor_text($last_posts[2]['post_subject'])), 0, $topic_title_length) . '...' : '',
	'LAST_X_POSTS_LONG_3'    => (isset($last_posts[2]['post_id'])) ? addslashes(censor_text($last_posts[2]['post_subject'])) : '',
	'LAST_X_POSTS_F_LONG_3'  => (isset($last_posts[2]['post_id'])) ? addslashes(censor_text($last_posts[2]['forum_name'])) : '',
	'LAST_X_POSTS_T_LONG_3'  => (isset($last_posts[2]['post_id'])) ? addslashes(censor_text($last_posts[2]['topic_title'])) : '',
	'LAST_X_POSTS_DATE_3'    => (isset($last_posts[2]['post_id'])) ? ($user->format_date($last_posts[2]['post_time'])) : '',	
	// Last 3 Posts made by User v.0.0.2 / 4seven / 2011	

	
    ), $rownr, 'change');}
 
    $db->sql_freeresult($result);
	
	}
	
// Last 3 X made by User v.0.0.2 / 4seven / 2011

?>